Subject: Re: [PATCH v0 5/5] cgroup: Assign subsystem IDs during compile time

From: Daniel Wagner <[email-masked]>
Date: Fri, 17 Aug 2012 10:48:18 +0200

On 17.08.2012 09:25, Li Zefan wrote:
> On 2012/8/17 7:20, Tejun Heo wrote:
>> On Thu, Aug 16, 2012 at 04:12:16PM +0200, Daniel Wagner wrote:
>>> From: Daniel Wagner <[email-masked]>
>>>
>>> We are able to safe some space when we assign the subsystem
>>> IDs at compile time. Instead of allocating per cgroup
>>> cgroup->subsys[CGROUP_SUBSYS_COUNT] where CGROUP_SUBSYS_COUNT is
>>> always 64, we allocate 12 + 1 at max (at this point there are 12
>>> subsystem).
>>
>> So, IIUC, this is effectively removing the capability to implement
>> modularized controller which isn't known at kernel compile time.  Am I
>> right?
>>
>
> I think so.

I am preparing an updated version which does not need the extra 1 
pointer. Some more preprocessor magic involved :)

>> I don't think that's a bad idea but if we're doing that, can't we make
>> things even simpler?  Do we need to distinguish in-kernel and module
>> at all?
>>
>> Li, what do you think about this?
>>
>
> I'm definitely all for simplicity, but I'm not sure if we can do better in
> simplifying the code for modularized cgroup subsystem. (I guess you didn't
> mean to remove this feature?)

The new version should also be simpler to review because I don't have to 
touch the loops everywhere.

daniel